/* 
   mj2ppm 2.0 Copyright (C) 2007 Marco Bisetto < marco [at] folgorante.net >
   This program comes with ABSOLUTELY NO WARRANTY; 
   This is free software, and you are welcome to redistribute it
   under certain conditions;

   Released under the terms of GNU GPLv3.

   mj2ppm converts the raw matrix generated by mj to a ppm image file.
   Background is white, R G B values are kept over 55.
   Insert in commandline the minimum treshold from which to color.

   mj2ppm converte la matrice in file ppm da stampare
   questo stampa su bianco mantenendo r g b sempre oltre 55
   accetta a linea di comando la soglia minima da cui colorare
 */



#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mj-3.0.h"

void conv(unsigned int xn, unsigned int yn, unsigned int ma,
	  unsigned int soglia)
{
    int cr, cg, cb;
    unsigned int a, b;
    unsigned short n;

    for (b = 0; b < yn; b++) {
	for (a = 0; a < xn; a++) {
	    fread(&n, sizeof(n), 1, stdin);
	    if (n < ma && n > soglia) {
		n -= soglia;
		n %= 1000;

		/* red */
		if (n < 200)
		    cr = 255;
		else if (n < 400)
		    cr = 255;
		else if (n < 600)
		    cr = 255 - (n - 400);
		else if (n < 800)
		    cr = 55;
		else if (n < 1000)
		    cr = 55 + (n - 800);

		/* green */
		if (n < 200)
		    cg = 255 - n;
		else if (n < 400)
		    cg = 55 + (n - 200);
		else if (n < 600)
		    cg = 255;
		else if (n < 800)
		    cg = 255;
		else if (n < 1000)
		    cg = 255;

		/* blue */
		if (n < 200)
		    cb = 255 - n;
		else if (n < 400)
		    cb = 55;
		else if (n < 600)
		    cb = 55;
		else if (n < 800)
		    cb = 55 + (n - 600);
		else if (n < 1000)
		    cb = 255;

		putchar(cr);
		putchar(cg);
		putchar(cb);
	    } else {
		putchar(255);
		putchar(255);
		putchar(255);
	    }
	}
    }
}

int main(int argc, char *argv[])
{
    struct mjim t;
    char *stip[2] = { "Mandelbrot", "Julia" };
    unsigned int soglia;

    if (argc == 2)
	soglia = atoi(argv[1]);
    else
	soglia = 0;


    fread(&t, sizeof(t), 1, stdin);

    printf("P6\n%d %d\n255\n", t.xn, t.yn);

    fprintf(stderr, "\n %s\n xn=%d\n yn=%d\n ma=%d\n mam2=%f\n x0=%f\n"
	    " y0=%f\n l0=%f\n xj=%f\n yj=%f\n",
	    stip[t.tipo], t.xn, t.yn, t.ma, t.mam2,
	    t.x0, t.y0, t.l0, t.xj, t.yj);

    conv(t.xn, t.yn, t.ma, soglia);
}
